package pogr;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
/**
 *
 * @author KarelSimanek
 */
public class AsciiFontSelector extends JDialog{
    
    /**
     * Private variable representing the font size value
     */
    private static int value;
    /**
     * Input type of font
     */
    private static Font f;
    /**
     * Auxiliary static class ascii
     */
    private static Ascii ascii;
    /**
     * Private variable represeting the successful confirmation of the dialog.
     */
    private static boolean OK;
    
    /**
     * Method for setting the internal variable representing the confirmation of the window to OK.
     * @param value Set confirm - OK
     */
    private void setOK(boolean value)
    {
        AsciiFontSelector.OK = value;
    }
    
    /**
     * Method for determining whether the OK value is true or not.
     * @return Value of variable OK
     */
    public boolean isOK()
    {
        return AsciiFontSelector.OK;
    }
    
    /*
     * Constructor of the custom dialog
     */
    public AsciiFontSelector(JFrame parent)
    {
        super(parent,"Ascii Font Selector");
        
        this.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        this.setModal(true);
        
        this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(java.awt.event.WindowEvent evt) {
                setOK(false);
                setVisible(false);
            }
        });
        
        spinner = new JSpinner(new SpinnerNumberModel(5,1,25,1));
        spinner.setBounds(10,10,150,20);
        spinner.addChangeListener(new ChangeListener()
        {
            @Override 
            public void stateChanged(ChangeEvent e)
            {
                SetValues();
                panel.repaint();
            }
        });
        SetValues();
        
       
        confirmButton = new JButton();
        confirmButton.setBounds(10,200,120,30);
        confirmButton.setText("Process");
        panel = new JPanel()
        {
            @Override
            public void paintComponent(Graphics g)
            {
                BufferedImage sample;
                g.setColor(Color.WHITE);
                g.fillRect(0,0, 200, 200);
                BufferedImage originalImage = Window.canvas.getOriginalSizeImage();
                Image scaledImage;
                
                scaledImage = originalImage.getScaledInstance(140,140,Image.SCALE_SMOOTH);
          
                 ascii = new Ascii();
                 f = new Font("Monospaced",Font.BOLD,AsciiFontSelector.value);
                 sample = ascii.Asciify(imageToBufferedImage(scaledImage), f);
                 g.drawImage(sample, 5, 5, null);
            }
        };
       
        panel.setBounds(10,40,150,150);
        
        this.add(panel);
        
        this.setSize(200,300);
        this.setLayout(null);
        this.add(confirmButton);
        this.add(panel);
        this.add(spinner);
        
        confirmButton.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed(ActionEvent e)
            {
                SetValues();
                setOK(true);
                setVisible(false);
            }
        });
    }
    
    /**
     * Auxiliary method for converting format Image to BufferedImage
     * @param im Input image
     * @return BufferedImage converted from the image
     */
    public static BufferedImage imageToBufferedImage(Image im) {
        BufferedImage bi = new BufferedImage
           (im.getWidth(null),im.getHeight(null),BufferedImage.TYPE_INT_RGB);
        Graphics bg = bi.getGraphics();
        bg.drawImage(im, 0, 0, null);
        bg.dispose();
        return bi;
    }
    
    /**
     * Auxiliary method for setting the private variable representing the font size value.
     */
    private void SetValues()
    {
        AsciiFontSelector.value = (int)spinner.getValue();
    }
    
    /**
     * Method for determining the private variable representing the font size value.
     * @return font size value selected in the selector.
     */
    public int getValues()
    {
        return AsciiFontSelector.value;
    }
    
    /**
     * Spinner for selecting the custom font size value
     */
    private JSpinner spinner;
    /**
     * Confirm button for confirming and closing the dialog
     */
    private JButton confirmButton;
    /**
     * Panel for displaying the miniature of the procedure applied on the original image
     */
    private JPanel panel;
    
}
